tests/basic ensure that the directory is actually an absolute path, not a relative...
[monkeysphere.git] / tests / basic
index 5e233aa0014ec9d9b801daa6c0beb837f27f500f..455c0578fb90d4a80f35fe79fe926ab9b307abcc 100755 (executable)
@@ -17,6 +17,10 @@ set -e
 # piped commands should return the code of the first non-zero return
 set -o pipefail
 
+export TESTDIR=$(dirname "$0")
+
+source "$TESTDIR"/common
+
 ## make sure that the right tools are installed to run the test.  the
 ## test has *more* requirements than plain ol' monkeysphere:
 which socat >/dev/null || { echo "You must have socat installed to run this test." ; exit 1; }
@@ -72,34 +76,6 @@ ssh_test() {
     fi
 }
 
-failed_cleanup() {
-    # FIXME: can we be more verbose here?
-    echo 'FAILED!'
-    read -p "press enter to cleanup and remove tmp:"
-
-    cleanup
-}
-
-get_gpg_prng_arg() {
-    if (gpg --quick-random --version >/dev/null 2>&1) ; then
-       echo quick-random
-    elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
-       echo debug-quick-random
-    fi
-}
-
-cleanup() {
-    echo "### removing temp dir..."
-    rm -rf "$TEMPDIR"
-
-    if [ "$SSHD_PID" ] ; then
-       echo "### killing off lingering sshd..."
-       kill "$SSHD_PID"
-    fi
-
-    wait
-}
-
 SSHD_PID=
 
 ## setup trap
@@ -112,15 +88,9 @@ trap failed_cleanup EXIT
 ## set up some variables to ensure that we're operating strictly in
 ## the tests, not system-wide:
 
-export TESTDIR=$(dirname "$0")
-
 # make temp dir
-TEMPDIR="$TESTDIR"/tmp
-if [ -e "$TEMPDIR" ] ; then
-    echo "tempdir '$TEMPDIR' already exists."
-    exit 1
-fi
-mkdir "$TEMPDIR"
+mkdir -p "$TESTDIR"/tmp
+TEMPDIR=$(mktemp -d ${TMPDIR:-$(cd "$TESTDIR" && printf "%s" $(pwd)/tmp)}/monkeyspheretest.XXXXXXX)
 
 # Use the local copy of executables first, instead of system ones.
 # This should help us test without installing.
@@ -154,8 +124,9 @@ cp -a "$TESTDIR"/home/admin "$TEMPDIR"/
 cp -a "$TESTDIR"/home/testuser "$TEMPDIR"/
 
 # set up environment for testuser
-TESTHOME="$TEMPDIR"/testuser
+export TESTHOME="$TEMPDIR"/testuser
 export GNUPGHOME="$TESTHOME"/.gnupg
+chmod 0700 "$GNUPGHOME"
 export SSH_ASKPASS="$TESTHOME"/.ssh/askpass
 export MONKEYSPHERE_HOME="$TESTHOME"/.monkeysphere
 cat <<EOF >> "$TESTHOME"/.ssh/config
@@ -182,25 +153,35 @@ EOF
 ######################################################################
 ### SERVER HOST SETUP
 
-# set up monkeysphere host
-echo "##################################################"
-echo "### configuring monkeysphere host..."
-mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/host
-
 # create a new host key
 echo "##################################################"
-echo "### generating server host key..."
+echo "### testing host key generation..."
+mkdir -p -m 750 "$MONKEYSPHERE_SYSDATADIR"/host
 # add gpg.conf with quick-random
 get_gpg_prng_arg >> "$MONKEYSPHERE_SYSCONFIGDIR"/host/gpg.conf
-echo | monkeysphere-host expert gen-key --length 1024 --expire 0 testhost
-# remove the gpg.conf
-rm "$MONKEYSPHERE_SYSCONFIGDIR"/host/gpg.conf
+echo | monkeysphere-host expert gen-key --length 1024 testhost
+
+# remove the host home for the next test
+rm -rf "$MONKEYSPHERE_SYSCONFIGDIR"/host
+
+# import host key
+echo "##################################################"
+echo "### testing host key importing..."
+ssh-keygen -b 1024 -t rsa -N '' -f "$TEMPDIR"/ssh_host_rsa_key
+monkeysphere-host expert import-key testhost < "$TEMPDIR"/ssh_host_rsa_key
 
-# FIXME: need to test import-key as well
+# change host key expiration
+echo "##################################################"
+echo "### setting host key expiration..."
+monkeysphere-host set-expire 1
+monkeysphere-host show-key
+# FIXME: how do we check that the expiration has really been set?
 
+echo "##################################################"
+echo "### getting host key fingerprint..."
 HOSTKEYID=$( monkeysphere-host show-key | grep '^OpenPGP fingerprint: ' | cut -f3 -d\  )
 
-# certify it with the "Admin's Key".
+# certify host key with the "Admin's Key".
 # (this would normally be done via keyservers)
 echo "##################################################"
 echo "### certifying server host key..."
@@ -252,7 +233,7 @@ gpgadmin --armor --export "$HOSTKEYID" | gpg --import
 # teach the "server" about the testuser's key
 echo "##################################################"
 echo "### export testuser key to server..."
-gpg --export testuser | monkeysphere-authentication gpg-cmd --import
+gpg --export testuser | monkeysphere-authentication expert gpg-cmd --import
 
 # update authorized_keys for user
 echo "##################################################"
@@ -301,6 +282,7 @@ chmod o-w "$TESTHOME"/.monkeysphere/authorized_user_ids
 
 # FIXME: addtest: remove admin as id-certifier and check ssh failure
 
+# FIXME: addtest: add hostname on host key
 # FIXME: addtest: revoke hostname on host key and check ssh failure
 
 # FIXME: addtest: revoke the host key and check ssh failure